<?php
include(dirname(__FILE__). '/../../config/config.inc.php');
/* SSL Tricks to bypass the redirect for the FrontController in 1.5 + */
include(dirname(__FILE__). '/../../init.php');
/* will include backward file */
include(dirname(__FILE__). '/cashenvoy.php');

$cashenvoy = new cashenvoy();
$db = Db::getInstance();

if(isset($_POST['ce_response'])){
	$transref = $_POST['ce_transref'];
	$cartid = substr($transref,0,-14);
	$cart = new Cart($cartid);
	$ctotal = number_format($cart->getOrderTotal(true, 3), 2, '.', '');
	$mertid = Configuration::get('CASHENVOY_MERCHANT_ID'); 
	global $cookie;
	if ($cartid!=(int)$cookie->id_cart){
		include(dirname(__FILE__).'/../../header.php');
		echo $cashenvoy->failedTX('Your CashEnvoy transaction was halted.<br>Your shopping cart is no longer valid.');
		include(dirname(__FILE__).'/../../footer.php');
	} else { 
		$request = 'mertid='.urlencode($mertid).'&transref='.urlencode($transref);
		$response = $cashenvoy->requery($request);
		$response = strip_tags(preg_replace('#(<title.*?>).*?(</title>)#', '$1$2', $response));
		$respdata = explode('-',$response);
		$cnt = count($respdata);
		@$r_transref = $respdata[0];
		@$r_status = $respdata[1];
		@$r_amount = $respdata[2];
		if ($cnt==3) {
			if($ctotal!=$r_amount && $r_status=='C00') { $r_status='C05'; $a='Transaction amount '; }
			$q = "UPDATE `"._DB_PREFIX_."cashenvoy_outcall` SET status='".($r_status)."' WHERE cartid='".$cartid."'";
			$db->Execute($q);
			$customer = new Customer((int)$cart->id_customer);
			$payment_method = Configuration::get('CASHENVOY_DISPLAY_NAME');
			switch($r_status) {
				case 'C00':
					$message = "CashEnvoy transaction successful. <br>Reference: $transref";
					$cashenvoy->validateOrder((int)$cartid, Configuration::get('PS_OS_PAYMENT'), (float)$r_amount,
					$payment_method, $message, NULL, NULL, false, $customer->secure_key);
					$order = new Order($cashenvoy->currentOrder);
					break;
				case 'C04':
					$message = "CashEnvoy transaction denied. <br>Reason: Insufficient funds. <br>Reference: $transref";
					$cashenvoy->validateOrder((int)$cartid,	Configuration::get('PS_OS_ERROR'), (float)$r_amount,
					$payment_method, $message, NULL, NULL, false, $customer->secure_key);
					break;
				case 'C05':
					$message = "CashEnvoy transaction failed. <br>Reason: ".@$a."Error occurred. Contact support@cashenvoy.com <br>Reference: $transref";
					$cashenvoy->validateOrder((int)$cartid,	Configuration::get('PS_OS_ERROR'), (float)$r_amount,
					$payment_method, $message, NULL, NULL, false, $customer->secure_key);
					break;
				case 'C03':
					$message = "CashEnvoy transaction failed. <br>Reason: No transaction record. <br>Reference: $transref";
					$cashenvoy->validateOrder((int)$cartid,	Configuration::get('PS_OS_ERROR'), (float)$ctotal,
					$payment_method, $message, NULL, NULL, false, $customer->secure_key);
					break;
				case '':
					$message = "We could not obtain the status of your transaction. <br>Please contact us quoting your transaction reference.<br>Reference: $transref";
					$cashenvoy->validateOrder((int)$cartid,	Configuration::get('PS_OS_ERROR'), (float)$r_amount,
					$payment_method, $message, NULL, NULL, false, $customer->secure_key);
					break;	
			}
			
			$msg = new Message(); $message = strip_tags($message, '<br>');
			if (Validate::isCleanHtml($message)){	
				$msg->message = $message; $msg->id_order = intval($cashenvoy->currentOrder);
				$msg->private = 0; $msg->add();
			}			
			if($r_status=='C00'){
				$url = 'order-confirmation.php?id_cart=';
				if (_PS_VERSION_ >= '1.5')
					$url = 'index.php?controller=order-confirmation&id_cart=';
				Tools::redirect($url.(int)($cartid).'&id_module='.(int)($cashenvoy->id).'&id_order='.(int)($cashenvoy->currentOrder).'&key='.$order->secure_key);
			} else {
				include(dirname(__FILE__).'/../../header.php');
				echo $cashenvoy->failedTX($message);
				include(dirname(__FILE__).'/../../footer.php');
			}	
		} else {
			include(dirname(__FILE__).'/../../header.php');
			echo $cashenvoy->failedTX("Your CashEnvoy transaction was not submitted.<br>Reason: $respdata[0]");
			include(dirname(__FILE__).'/../../footer.php');
		}
	}
} elseif(isset($_POST['ce_notifyurl'])) { 
	$cartid = substr($_POST['ce_transref'],0,-14);
	if(is_numeric($_POST['ce_amount'])) { $amt = $_POST['ce_amount']+0; } else { $amt = ''; }
	if(!ctype_digit($cartid) || !ctype_digit($_POST['ce_transref']) || !$amt || $amt<Configuration::get('CASHENVOY_MINIMUM_AMOUNT')){ 
		include(dirname(__FILE__).'/../../header.php');
		echo $cashenvoy->failedTX('Your CashEnvoy transaction was not submitted.<br>Your shopping cart is no longer valid.');
		include(dirname(__FILE__).'/../../footer.php');
	}
	$sql = "INSERT IGNORE INTO "._DB_PREFIX_."cashenvoy_outcall (cartid, transref, amount, time) 
	VALUES ('".($cartid)."', '".($_POST['ce_transref'])."', '".($_POST['ce_amount'])."', NOW())";
	$sql2 = "UPDATE `"._DB_PREFIX_."cart` SET transref='".($_POST['ce_transref'])."' WHERE id_cart='".$cartid."'";
	$db->Execute($sql);
	$db->Execute($sql2);
	$url = Tools::getHttpHost(true).__PS_BASE_URI__.'modules/'.$_POST['ce_notifyurl'].'/validation.php';
	
	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
	<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<title>Pay with CashEnvoy</title>
	</head>
	<body>
	<center style="font-family:\'Century Gothic\';color:#c00;font-size:11px">
	<img src="images/preloader.gif" width="42" height="42" align="absmiddle" />
	<b>loading</b></center>	
	<form method="post" name="submit2cepay_form" action="https://www.cashenvoy.com/'.$_POST['ce_action'].'/?cmd=cepay" target="_self"/>
	<input type="hidden" name="ce_merchantid" value="'.$_POST['ce_merchantid'].'"/>
	<input type="hidden" name="ce_transref" value="'.$_POST['ce_transref'].'"/>
	<input type="hidden" name="ce_amount" value="'.$_POST['ce_amount'].'"/>
	<input type="hidden" name="ce_customerid" value="'.$_POST['ce_customerid'].'"/>
	<input type="hidden" name="ce_memo" value="'.$_POST['ce_memo'].'"/>
	<input type="hidden" name="ce_data" value="'.$_POST['ce_data'].'"/>
	<input type="hidden" name="ce_notifyurl" value="'.$url.'"/>
	<input type="hidden" name="ce_window" value="parent"/>
	</form>
	<script language="javascript">document.submit2cepay_form.submit()</script>
	</body></html>';
} else {
	$mertid = Configuration::get('CASHENVOY_MERCHANT_ID'); 
	$payment_method = Configuration::get('CASHENVOY_DISPLAY_NAME');
	$query = "select a.* from ". _DB_PREFIX_ ."cashenvoy_outcall a, `". _DB_PREFIX_ ."cart` b 
	where a.cartid=b.id_cart and a.status is null and (TIME_TO_SEC(timediff(now(),a.time))/60)>20 order by a.cartid";
	$rows = $db->ExecuteS($query);
	foreach($rows as $key=>$value){ 
		$transref = $value['transref'];
		$cartid = substr($transref,0,-14);
		$cart = new Cart($cartid);
		if (Validate::isLoadedObject($cart)){
			$ctotal = number_format($value['amount'], 2, '.', '');	
			$request = 'mertid='.urlencode($mertid).'&transref='.urlencode($transref);
			$response = $cashenvoy->requery($request);
			$response = strip_tags(preg_replace('#(<title.*?>).*?(</title>)#', '$1$2', $response));
			$respdata = explode('-',$response);
			$cnt = count($respdata);
			@$r_transref = $respdata[0];
			@$r_status = $respdata[1];
			@$r_amount = $respdata[2];
			if ($cnt==3) {
				if($ctotal!=$r_amount && $r_status=='C00') { $r_status='C05'; $a='Transaction amount '; }
				$q = "UPDATE `"._DB_PREFIX_."cashenvoy_outcall` SET status='".($r_status)."' WHERE cartid='".$cartid."'";
				$db->Execute($q);
				$customer = new Customer((int)$cart->id_customer);
				switch($r_status) {
					case 'C00':
						$message = "CashEnvoy transaction successful. <br>Reference: $transref";
						$cashenvoy->validateOrder((int)$cartid, Configuration::get('PS_OS_PAYMENT'), (float)$r_amount,
						$payment_method, $message, NULL, NULL, false, $customer->secure_key);
						break;
					case 'C04':
						$message = "CashEnvoy transaction denied. <br>Reason: Insufficient funds. <br>Reference: $transref";
						$cashenvoy->validateOrder((int)$cartid,	Configuration::get('PS_OS_ERROR'), (float)$r_amount,
						$payment_method, $message, NULL, NULL, false, $customer->secure_key);
						break;
					case 'C05':
						$message = "CashEnvoy transaction failed. <br>Reason: ".@$a."Error occurred. Contact support@cashenvoy.com <br>Reference: $transref";
						$cashenvoy->validateOrder((int)$cartid,	Configuration::get('PS_OS_ERROR'), (float)$r_amount,
						$payment_method, $message, NULL, NULL, false, $customer->secure_key);
						break;
					case 'C03':
						$message = "CashEnvoy transaction failed. <br>Reason: No transaction record. <br>Reference: $transref";
						$cashenvoy->validateOrder((int)$cartid,	Configuration::get('PS_OS_ERROR'), (float)$r_amount,
						$payment_method, $message, NULL, NULL, false, $customer->secure_key);
						break;
				}
				if($r_status!=''){
					$msg = new Message(); $message = strip_tags($message, '<br>');
					if (Validate::isCleanHtml($message)){	
						$msg->message = $message; $msg->id_order = intval($cashenvoy->currentOrder);
						$msg->private = 0; $msg->add();
					}
				}
			}
		}
	}
}